if type(isOn) ~= "boolean" then
	local isOn = true
end

local hunterTrackingAid = LibStub("AceAddon-3.0"):NewAddon("HunterTrackingAid", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("HunterTrackingAid", true)
local htaLDB = LibStub("LibDataBroker-1.1"):NewDataObject("hta", {
	type = "data source",
	text = "hta",
	icon = "Interface\\Icons\\Ability_Stealth",
	OnClick = function(clickedframe, button)
			if button == "RightButton" then
				isOn = not isOn
			elseif button == "LeftButton" then
				hunterTrackingAid:SetTracking(L["unit_types"]()["hiddens"])
			end
		end,
	OnTooltipShow = function ()
			GameTooltip:AddLine(L["Autotracking is %s"]:format( (isOn and L["ON"] or L["OFF"]) ))
			GameTooltip:AddLine("---")
			GameTooltip:AddLine(L["<Left Click> turns on tracking of hiddens"])
			GameTooltip:AddLine(L["<Right Click> turns autotracking ON/OFF"])
		end
})
local icon = LibStub("LibDBIcon-1.0")

function hunterTrackingAid:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("htaSavedDB", {
		profile = {
			minimap = {
				hide = false,
			},
		},
	})
	icon:Register("hta", htaLDB, self.db.profile.minimap)
end

function hunterTrackingAid:OnPlayerTargetChanged()
	if not isOn then return end

	local unitType = UnitCreatureType("target")
	local trackingId = L["unit_types"]()[unitType]
	self:SetTracking(trackingId)
end

function hunterTrackingAid:SetTracking(trackingId)
		local count = GetNumTrackingTypes();
		for i=1,count do 
			local name, texture, active, category = GetTrackingInfo(i);

			if i ~= trackingId then
				local shouldSwitchOff = (category == "spell") 
											and not self:contains(L["protected_trackings"], name)
											and active
				if shouldSwitchOff then
					SetTracking(i, false)
				end
			else
				if not active then
					SetTracking(trackingId, true)
				end
			end
		end
end

function hunterTrackingAid:contains( hay, needle )
	for i=1,table.getn(hay) do
		if hay[i] == needle then
			return true
		end
	end
	return false
end

function hunterTrackingAid:PrintTrackings()
	for i=1,GetNumTrackingTypes() do 
		name, texture, active, category = GetTrackingInfo(i);
		if category == "spell" then
			DEFAULT_CHAT_FRAME:AddMessage(i .. ". " .. name .. " ("..category..") " .. (active and "+" or "-"));
		end
	end
end

hunterTrackingAid:RegisterEvent("PLAYER_TARGET_CHANGED", "OnPlayerTargetChanged")
